function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import { arrayReduce } from 'fast-loops';
import { fromMarkdown as parseMarkdown } from 'mdast-util-from-markdown';
import getHeadingId from './getHeadingId';
import getHeadingContent from './getHeadingContent';
var defaultConfig = {
  minDepth: 2,
  maxDepth: 4
};
export default function getHeadings(markdown) {
  var customConfig = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var config = _objectSpread(_objectSpread({}, defaultConfig), customConfig);
  var minDepth = config.minDepth,
    maxDepth = config.maxDepth;
  var ast = parseMarkdown(markdown);
  return arrayReduce(ast.children, function (headings, child) {
    if (child.type === 'heading' && child.depth >= minDepth && child.depth <= maxDepth) {
      var content = getHeadingContent(child.children);
      headings.push({
        id: getHeadingId(content.join('-')),
        children: content.join(' '),
        depth: child.depth
      });
    }
    return headings;
  }, []);
}